"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrencySymbol = exports.formatPrice = exports.classNames = exports.tractStackGraph = exports.getLogo = exports.HtmlAstToReact = exports.getControllerPayload = exports.SvgShapeOutsidePayload = exports.SvgImageMaskPayload = exports.Svg = exports.SocialIcons = exports.viewportWidth = exports.getScrollbarSize = exports.useInterval = void 0;
// eslint-disable-next-line @typescript-eslint/no-unused-vars, no-unused-vars
var react_1 = __importStar(require("react"));
var ReactDOMServer = __importStar(require("react-dom/server"));
var shapes_1 = require("./shapes");
var lexer_1 = require("./lexer");
var concierge_1 = require("./concierge");
global.Buffer = global.Buffer || require("buffer").Buffer;
function useInterval(callback, delay) {
    var savedCallback = (0, react_1.useRef)();
    (0, react_1.useEffect)(function () {
        savedCallback.current = callback;
    }, [callback]);
    (0, react_1.useEffect)(function () {
        function tick() {
            savedCallback.current();
        }
        if (delay !== null) {
            var id_1 = setInterval(tick, delay);
            return function () { return clearInterval(id_1); };
        }
    }, [delay]);
}
exports.useInterval = useInterval;
// from https://tobbelindstrom.com/blog/measure-scrollbar-width-and-height/
var getScrollbarSize = function () {
    var body = document.body;
    var scrollDiv = document.createElement("div");
    // Append element with defined styling
    scrollDiv.setAttribute("style", "width: 1337px; height: 1337px; position: absolute; left: -9999px; overflow: scroll;");
    body.appendChild(scrollDiv);
    // Collect width & height of scrollbar
    var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
    // Remove element
    body.removeChild(scrollDiv);
    return scrollbarWidth;
};
exports.getScrollbarSize = getScrollbarSize;
exports.viewportWidth = {
    mobile: 600,
    tablet: 1080,
    desktop: 1920,
    server: 0,
};
var SocialIcons = function (_a) {
    var name = _a.name, _b = _a.ariaHidden, ariaHidden = _b === void 0 ? true : _b, _c = _a.className, className = _c === void 0 ? "" : _c;
    switch (name) {
        case "Twitter":
            return (react_1.default.createElement("svg", { fill: "currentColor", viewBox: "0 0 24 24", className: className, "aria-hidden": ariaHidden },
                react_1.default.createElement("path", { d: "M8.29 20.251c7.547 0 11.675-6.253 11.675-11.675 0-.178 0-.355-.012-.53A8.348 8.348 0 0022 5.92a8.19 8.19 0 01-2.357.646 4.118 4.118 0 001.804-2.27 8.224 8.224 0 01-2.605.996 4.107 4.107 0 00-6.993 3.743 11.65 11.65 0 01-8.457-4.287 4.106 4.106 0 001.27 5.477A4.072 4.072 0 012.8 9.713v.052a4.105 4.105 0 003.292 4.022 4.095 4.095 0 01-1.853.07 4.108 4.108 0 003.834 2.85A8.233 8.233 0 012 18.407a11.616 11.616 0 006.29 1.84" })));
        case "GitLab":
            return (react_1.default.createElement("svg", { fill: "currentColor", viewBox: "0 0 380 380", className: className, "aria-hidden": ariaHidden },
                react_1.default.createElement("path", { d: "m 361.18739,157.75722 -0.49207,-1.29831 -47.63959,-128.362872 a 12.411079,12.813709 0 0 0 -4.90247,-6.09639 12.75735,13.171214 0 0 0 -14.57983,0.809088 12.75735,13.171214 0 0 0 -4.22815,6.623239 L 257.17853,131.03847 H 126.92599 L 94.75925,29.431975 a 12.502203,12.907789 0 0 0 -4.228152,-6.642055 12.75735,13.171214 0 0 0 -14.579829,-0.809088 12.520428,12.926605 0 0 0 -4.902467,6.09639 l -47.730714,128.306428 -0.473844,1.29831 a 88.46311,91.332957 0 0 0 29.341904,105.55787 l 0.164024,0.1317 0.437395,0.31988 72.571093,56.10937 35.90283,28.05469 21.86974,17.0473 a 14.707403,15.184527 0 0 0 17.7874,0 l 21.86974,-17.0473 35.90282,-28.05469 73.0085,-56.44806 0.18224,-0.15053 a 88.499559,91.370589 0 0 0 29.30546,-105.44497 z" })));
        case "GitHub":
            return (react_1.default.createElement("svg", { fill: "currentColor", viewBox: "0 0 24 24", className: className, "aria-hidden": ariaHidden },
                react_1.default.createElement("path", { fillRule: "evenodd", d: "M12 2C6.477 2 2 6.484 2 12.017c0 4.425 2.865 8.18 6.839 9.504.5.092.682-.217.682-.483 0-.237-.008-.868-.013-1.703-2.782.605-3.369-1.343-3.369-1.343-.454-1.158-1.11-1.466-1.11-1.466-.908-.62.069-.608.069-.608 1.003.07 1.531 1.032 1.531 1.032.892 1.53 2.341 1.088 2.91.832.092-.647.35-1.088.636-1.338-2.22-.253-4.555-1.113-4.555-4.951 0-1.093.39-1.988 1.029-2.688-.103-.253-.446-1.272.098-2.65 0 0 .84-.27 2.75 1.026A9.564 9.564 0 0112 6.844c.85.004 1.705.115 2.504.337 1.909-1.296 2.747-1.027 2.747-1.027.546 1.379.202 2.398.1 2.651.64.7 1.028 1.595 1.028 2.688 0 3.848-2.339 4.695-4.566 4.943.359.309.678.92.678 1.855 0 1.338-.012 2.419-.012 2.747 0 .268.18.58.688.482A10.019 10.019 0 0022 12.017C22 6.484 17.522 2 12 2z", clipRule: "evenodd" })));
        default:
            return react_1.default.createElement(react_1.default.Fragment, null);
    }
};
exports.SocialIcons = SocialIcons;
var Svg = function (shapeName, viewportKey, id) {
    var shapeData = typeof shapes_1.SvgPanes[shapeName] !== "undefined" &&
        typeof shapes_1.SvgPanes[shapeName][viewportKey] !== "undefined"
        ? shapes_1.SvgPanes[shapeName][viewportKey]
        : null;
    return (shapeData && (react_1.default.createElement("svg", { id: "svg__".concat(id), "data-name": "svg__".concat(shapeName, "--").concat(viewportKey), xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 ".concat(shapeData.viewBox[0], " ").concat(shapeData.viewBox[1]), className: "svg svg__".concat(shapeName, " svg__").concat(shapeName, "--").concat(viewportKey) },
        react_1.default.createElement("desc", { id: "desc" }, "decorative background"),
        react_1.default.createElement("g", null,
            react_1.default.createElement("path", { d: shapeData.path })))));
};
exports.Svg = Svg;
var SvgImageMaskPayload = function (shapeName, thisId, viewportKey) {
    var shape = (0, exports.Svg)(shapeName, viewportKey, thisId);
    var svgString = typeof shape === "object"
        ? ReactDOMServer.renderToStaticMarkup(shape)
        : false;
    var b64 = typeof svgString === "string"
        ? Buffer.from(svgString, "utf8").toString("base64")
        : null;
    var dataUri = b64 && "data:image/svg+xml;base64,".concat(b64);
    var css = dataUri
        ? "-webkit-mask-image: url(\"".concat(dataUri, "\"); mask-image: url(\"").concat(dataUri, "\"); ") +
            "mask-repeat: no-repeat; -webkit-mask-size: 100% AUTO; mask-size: 100% AUTO; "
        : "";
    return css;
};
exports.SvgImageMaskPayload = SvgImageMaskPayload;
var SvgShapeOutsidePayload = function (shapeName, viewportKey, thisId, paneHeight, isModal, modalPayload) {
    if (isModal === void 0) { isModal = false; }
    if (modalPayload === void 0) { modalPayload = false; }
    var thisWidth = exports.viewportWidth[viewportKey];
    var shapeData = !modalPayload &&
        typeof shapes_1.SvgPanes[shapeName] !== "undefined" &&
        typeof shapes_1.SvgPanes[shapeName][viewportKey] !== "undefined"
        ? shapes_1.SvgPanes[shapeName][viewportKey]
        : typeof modalPayload === "object" &&
            typeof shapes_1.SvgModals[shapeName] !== "undefined"
            ? shapes_1.SvgModals[shapeName]
            : null;
    if (shapeData === null)
        return null;
    var multiplier = (modalPayload === null || modalPayload === void 0 ? void 0 : modalPayload.zoomFactor)
        ? parseFloat(parseFloat(modalPayload.zoomFactor).toFixed(4))
        : 1;
    var width = parseInt(shapeData.viewBox[0]) * multiplier;
    var height = parseInt(shapeData.viewBox[1]) * multiplier;
    var cut = parseInt(shapeData.cut) * multiplier;
    var paddingLeft = parseInt(modalPayload === null || modalPayload === void 0 ? void 0 : modalPayload.paddingLeft) * multiplier || 0;
    var paddingTop = parseInt(modalPayload === null || modalPayload === void 0 ? void 0 : modalPayload.paddingTop) * multiplier || 0;
    var viewBox = (!modalPayload && {
        left: "0 0 ".concat(cut, " ").concat(width),
        right: "".concat(cut, " 0 ").concat(width - cut, " ").concat(height),
        leftMask: "0 0 ".concat(cut, " ").concat(height),
        rightMask: "".concat(cut, " 0 ").concat(width - cut, " ").concat(height),
        rightMaskWidth: thisWidth - cut,
    }) || {
        left: "".concat(-paddingLeft, " ").concat(-paddingTop, " ").concat(cut + paddingLeft, " ").concat(paneHeight),
        right: "".concat(cut, " ").concat(-paddingTop, " ").concat(thisWidth - (width - cut + paddingLeft), " ").concat(paneHeight),
        leftMask: "".concat(-paddingLeft, " ").concat(-paddingTop, " ").concat(cut + paddingLeft, " ").concat(paneHeight),
        rightMask: "".concat(cut, " ").concat(-paddingTop, " ").concat(thisWidth - (width - cut + paddingLeft), " ").concat(paneHeight),
        rightMaskWidth: thisWidth - (width - cut + paddingLeft),
    };
    var thisWidthLeft = cut + paddingLeft;
    var thisWidthRight = thisWidth - thisWidthLeft;
    var leftMaskSvg = (react_1.default.createElement("svg", { id: "svg__".concat(thisId, "--shape-outside-left-mask"), "data-name": "svg-shape-outside-mask__".concat(shapeName, "-left--").concat(viewportKey), xmlns: "http://www.w3.org/2000/svg", viewBox: viewBox.leftMask, className: "svg svg-shape-outside svg-shape-outside__".concat(shapeName, "-left svg-shape-outside__").concat(shapeName, "--").concat(viewportKey, " svg-shape-outside__").concat(shapeName, "-left--").concat(viewportKey) },
        react_1.default.createElement("desc", { id: "desc" }, "decorative background"),
        react_1.default.createElement("mask", { id: "svg__".concat(thisId, "--shape-outside-left-mask-cutout") },
            react_1.default.createElement("rect", { fill: "white", x: -paddingLeft, y: -paddingTop, width: cut + paddingLeft, height: paneHeight }),
            react_1.default.createElement("g", { transform: "scale(".concat(multiplier, " ").concat(multiplier, ")") },
                react_1.default.createElement("path", { d: isModal ? shapeData.innerPath : shapeData.path }))),
        react_1.default.createElement("rect", { mask: "url(#svg__".concat(thisId, "--shape-outside-left-mask-cutout)"), x: -paddingLeft, y: -paddingTop, width: cut + paddingLeft, height: paneHeight })));
    var rightMaskSvg = (react_1.default.createElement("svg", { id: "svg__".concat(thisId, "--shape-outside-right-mask"), "data-name": "svg-shape-outside-mask__".concat(shapeName, "-right--").concat(viewportKey), xmlns: "http://www.w3.org/2000/svg", viewBox: viewBox.rightMask, className: "svg svg-shape-outside svg-shape-outside__".concat(shapeName, "-right svg-shape-outside__").concat(shapeName, "--").concat(viewportKey, " svg-shape-outside__").concat(shapeName, "-right--").concat(viewportKey) },
        react_1.default.createElement("desc", { id: "desc" }, "decorative background"),
        react_1.default.createElement("mask", { id: "svg__".concat(thisId, "--shape-outside-right-mask-cutout") },
            react_1.default.createElement("rect", { fill: "white", x: cut, y: -paddingTop, width: viewBox.rightMaskWidth, height: paneHeight }),
            react_1.default.createElement("g", { transform: "scale(".concat(multiplier, " ").concat(multiplier, ")") },
                react_1.default.createElement("path", { d: isModal ? shapeData.innerPath : shapeData.path }))),
        react_1.default.createElement("rect", { mask: "url(#svg__".concat(thisId, "--shape-outside-right-mask-cutout)"), x: cut, y: -paddingTop, width: viewBox.rightMaskWidth, height: paneHeight })));
    var svgStringLeft = ReactDOMServer.renderToStaticMarkup(leftMaskSvg);
    var b64Left = typeof svgStringLeft === "string"
        ? Buffer.from(svgStringLeft, "utf8").toString("base64")
        : null;
    var leftMask = "data:image/svg+xml;base64,".concat(b64Left);
    var svgStringRight = ReactDOMServer.renderToStaticMarkup(rightMaskSvg);
    var b64Right = typeof svgStringRight === "string"
        ? Buffer.from(svgStringRight, "utf8").toString("base64")
        : null;
    var rightMask = "data:image/svg+xml;base64,".concat(b64Right);
    var left = (react_1.default.createElement("svg", { id: "svg__".concat(thisId, "--shape-outside-left"), "data-name": "svg-shape-outside__".concat(shapeName, "--").concat(viewportKey), xmlns: "http://www.w3.org/2000/svg", viewBox: viewBox.leftMask, className: "svg svg-shape-outside svg-shape-outside-left svg-shape-outside__".concat(shapeName, "-left ") +
            "svg-shape-outside__".concat(shapeName, "-left--").concat(viewportKey) },
        react_1.default.createElement("desc", { id: "desc" }, "decorative background"),
        react_1.default.createElement("g", { transform: "scale(".concat(multiplier, " ").concat(multiplier, ")") },
            react_1.default.createElement("path", { d: isModal ? shapeData.innerPath : shapeData.path }))));
    var right = (react_1.default.createElement("svg", { id: "svg__".concat(thisId, "--shape-outside-right"), "data-name": "svg-shape-outside__".concat(shapeName, "--").concat(viewportKey), xmlns: "http://www.w3.org/2000/svg", viewBox: viewBox.rightMask, className: "svg svg-shape-outside svg-shape-outside-right svg-shape-outside__".concat(shapeName, "-right ") +
            "svg-shape-outside__".concat(shapeName, "-right--").concat(viewportKey) },
        react_1.default.createElement("desc", { id: "desc" }, "decorative background"),
        react_1.default.createElement("g", { transform: "scale(".concat(multiplier, " ").concat(multiplier, ")") },
            react_1.default.createElement("path", { d: isModal ? shapeData.innerPath : shapeData.path }))));
    var isShapeOutside = !isModal
        ? "svg__shape-outside svg__shape-outside--".concat(viewportKey, "-").concat(shapeName)
        : "";
    var shape = (react_1.default.createElement("svg", { id: "svg__".concat(thisId), "data-name": "svg__".concat(shapeName, "--").concat(viewportKey), xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 ".concat(shapeData.viewBox[0], " ").concat(shapeData.viewBox[1]), className: "svg ".concat(isShapeOutside, " svg__").concat(shapeName, "--").concat(viewportKey) },
        react_1.default.createElement("desc", { id: "desc" }, "decorative background"),
        react_1.default.createElement("g", null,
            react_1.default.createElement("path", { d: shapeData.path }))));
    var cssShapeOutside = !isModal && typeof modalPayload !== "object"
        ? "#svg__".concat(thisId, "--shape-outside-left { float:left; shape-outside: url(").concat(leftMask, "); } ") +
            "#svg__".concat(thisId, "--shape-outside-right { float:right; shape-outside: url(").concat(rightMask, "); } ")
        : typeof modalPayload === "object"
            ? "#svg__".concat(thisId, "--shape-outside-left { ") +
                "width: calc( var(--scale) * ".concat(thisWidthLeft, " * 1px ); ") +
                "float:left; shape-outside: url(".concat(leftMask, "); } ") +
                "#svg__".concat(thisId, "--shape-outside-right { ") +
                "width: calc( var(--scale) * ".concat(thisWidthRight, " * 1px ); ") +
                "float:right; shape-outside: url(".concat(rightMask, "); } ")
            : "";
    var cssModal = typeof modalPayload === "object"
        ? "#svg__".concat(thisId, ", #svg__").concat(thisId, " ") +
            "{ width: calc(var(--scale) * ".concat(width, " * 1px ); ") +
            "margin-left: calc( var(--scale) * ".concat(paddingLeft, " * 1px ); ") +
            "margin-top: calc( var(--scale) * ".concat(paddingTop, " * 1px ); } ")
        : "";
    return {
        shape: shape,
        left: left,
        right: right,
        leftMask: leftMask,
        rightMask: rightMask,
        css: "".concat(cssShapeOutside, " ").concat(cssModal),
    };
};
exports.SvgShapeOutsidePayload = SvgShapeOutsidePayload;
var getControllerPayload = function (isExpanded, viewportKey) {
    var shapeName = isExpanded ? "controllerExpanded" : "controllerMinimized";
    var thisId = "".concat(shapeName, "-").concat(viewportKey);
    return (0, exports.SvgImageMaskPayload)(shapeName, thisId, viewportKey);
};
exports.getControllerPayload = getControllerPayload;
var HtmlAstToReact = function (payload, element, thisClassNames, hooks, memory) {
    if (element === void 0) { element = false; }
    if (thisClassNames === void 0) { thisClassNames = {}; }
    if (memory === void 0) { memory = {}; }
    // recursive function
    var contents, rawElement, raw;
    if (element)
        raw = element;
    else if (typeof (payload === null || payload === void 0 ? void 0 : payload.ast) === "object")
        raw = payload.ast;
    else
        return null;
    var composed = raw.map(function (e, idx) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
        var thisId = idx;
        if ((e === null || e === void 0 ? void 0 : e.type) === "text") {
            if ((e === null || e === void 0 ? void 0 : e.value) === "\n")
                return null;
            return e === null || e === void 0 ? void 0 : e.value;
        }
        var injectClassNames;
        var injectClassNamesRaw = (e === null || e === void 0 ? void 0 : e.tagName) && typeof thisClassNames[e === null || e === void 0 ? void 0 : e.tagName] !== "undefined"
            ? thisClassNames[e === null || e === void 0 ? void 0 : e.tagName]
            : "";
        if (injectClassNamesRaw && typeof injectClassNamesRaw === "string") {
            injectClassNames = injectClassNamesRaw;
        }
        else if ((e === null || e === void 0 ? void 0 : e.tagName) &&
            injectClassNamesRaw &&
            typeof injectClassNamesRaw === "object") {
            if ((e === null || e === void 0 ? void 0 : e.tagName) && typeof memory[e === null || e === void 0 ? void 0 : e.tagName] !== "undefined")
                memory[e.tagName] = memory[e.tagName] + 1;
            else
                memory[e.tagName] = 0;
            injectClassNames = injectClassNamesRaw[memory[e.tagName]];
        }
        switch (e === null || e === void 0 ? void 0 : e.tagName) {
            case "p":
                contents = (_a = e === null || e === void 0 ? void 0 : e.children) === null || _a === void 0 ? void 0 : _a.map(function (p) {
                    // use recursion to compose the MarkdownParagraph
                    return (0, exports.HtmlAstToReact)(payload, [p], thisClassNames, hooks, memory);
                });
                // is this an image or belief codeHook? (only uses first image)
                if (((e === null || e === void 0 ? void 0 : e.children.length) &&
                    typeof e.children[0].tagName !== "undefined" &&
                    e.children[0].tagName === "code") ||
                    (contents &&
                        (contents === null || contents === void 0 ? void 0 : contents.length) &&
                        contents[0] &&
                        contents[0][0] &&
                        (((_b = contents[0][0].props) === null || _b === void 0 ? void 0 : _b.image) || contents[0][0].tagName === "code")))
                    return react_1.default.createElement("div", { key: thisId }, contents[0][0]);
                // else it's a paragraph ... inject classNames
                return (react_1.default.createElement("p", { key: thisId, className: classNames(injectClassNames) }, contents));
            case "h1":
            case "h2":
            case "h3":
            case "h4":
            case "h5":
            case "h6": {
                var Tag = e === null || e === void 0 ? void 0 : e.tagName;
                return (react_1.default.createElement(Tag, { className: classNames(injectClassNames), key: thisId }, e === null || e === void 0 ? void 0 : e.children[0].value));
            }
            case "a":
                if (typeof ((_c = e === null || e === void 0 ? void 0 : e.properties) === null || _c === void 0 ? void 0 : _c.href) === "string" &&
                    ((_d = e === null || e === void 0 ? void 0 : e.children[0]) === null || _d === void 0 ? void 0 : _d.type) === "text" &&
                    typeof ((_e = e === null || e === void 0 ? void 0 : e.children[0]) === null || _e === void 0 ? void 0 : _e.value) === "string") {
                    // check for buttons action payload
                    // requires match on button's urlTarget === link's href
                    var isButton = void 0;
                    if (typeof (payload === null || payload === void 0 ? void 0 : payload.buttonData) === "object" &&
                        Object.keys(payload === null || payload === void 0 ? void 0 : payload.buttonData).length) {
                        var key = Object.keys(payload === null || payload === void 0 ? void 0 : payload.buttonData).find(function (target) { var _a, _b; return ((_a = payload === null || payload === void 0 ? void 0 : payload.buttonData[target]) === null || _a === void 0 ? void 0 : _a.urlTarget) === ((_b = e === null || e === void 0 ? void 0 : e.properties) === null || _b === void 0 ? void 0 : _b.href); });
                        isButton = payload === null || payload === void 0 ? void 0 : payload.buttonData[key];
                    }
                    if (isButton) {
                        // inject button with callback function, add css className
                        var thisButtonPayload_1 = (0, lexer_1.lispLexer)(isButton === null || isButton === void 0 ? void 0 : isButton.callbackPayload);
                        var injectPayload = function () {
                            (0, concierge_1.concierge)(thisButtonPayload_1, hooks, payload.parent);
                        };
                        return (react_1.default.createElement("button", { type: "button", className: isButton.className, key: thisId, onClick: injectPayload }, (_f = e === null || e === void 0 ? void 0 : e.children[0]) === null || _f === void 0 ? void 0 : _f.value));
                    }
                    // else, treat at internal link
                    // ...TODO: add check here and use a href for external links
                    var thisPayload_1 = (0, lexer_1.lispLexer)("(hookGotoStoryFragment (".concat((_g = e === null || e === void 0 ? void 0 : e.properties) === null || _g === void 0 ? void 0 : _g.href, "))"));
                    return (react_1.default.createElement("a", { className: classNames(injectClassNames), onClick: function () { return (0, concierge_1.concierge)(thisPayload_1, hooks); }, key: thisId }, (_h = e === null || e === void 0 ? void 0 : e.children[0]) === null || _h === void 0 ? void 0 : _h.value));
                }
                break;
            case "img": {
                var GatsbyImage = hooks.GatsbyImage;
                // is this case for gatsby image? = png, jpg ... != svg
                var pass = /\.[A-Za-z0-9]+$/;
                var extcheck = (_k = (_j = e === null || e === void 0 ? void 0 : e.properties) === null || _j === void 0 ? void 0 : _j.src) === null || _k === void 0 ? void 0 : _k.match(pass);
                if (extcheck && (extcheck[0] === ".png" || extcheck[0] === ".jpg")) {
                    // imageData in this case is an array ... assumes image is first element
                    var thisImageDataRaw = (_l = payload === null || payload === void 0 ? void 0 : payload.imageData) === null || _l === void 0 ? void 0 : _l.filter(function (image) { var _a; return image.filename === ((_a = e === null || e === void 0 ? void 0 : e.properties) === null || _a === void 0 ? void 0 : _a.src); })[0];
                    var thisImageData = thisImageDataRaw &&
                        typeof thisImageDataRaw[payload === null || payload === void 0 ? void 0 : payload.viewportKey] !== "undefined" &&
                        ((_o = (_m = thisImageDataRaw[payload.viewportKey]) === null || _m === void 0 ? void 0 : _m.childImageSharp) === null || _o === void 0 ? void 0 : _o.gatsbyImageData);
                    var objectFitMode = (payload === null || payload === void 0 ? void 0 : payload.mode) === "paragraph__markdown" ? "contain" : "cover";
                    return (react_1.default.createElement(GatsbyImage, { className: classNames(injectClassNames), key: thisId, alt: (_p = e === null || e === void 0 ? void 0 : e.properties) === null || _p === void 0 ? void 0 : _p.alt, image: thisImageData, objectFit: objectFitMode }));
                }
                else if (extcheck && extcheck[0] === ".svg") {
                    var thisImageDataRaw = (_q = payload === null || payload === void 0 ? void 0 : payload.imageData) === null || _q === void 0 ? void 0 : _q.filter(function (image) { var _a; return image.filename === ((_a = e === null || e === void 0 ? void 0 : e.properties) === null || _a === void 0 ? void 0 : _a.src); })[0];
                    return (react_1.default.createElement("img", { key: thisId, src: (_r = thisImageDataRaw === null || thisImageDataRaw === void 0 ? void 0 : thisImageDataRaw.localFile) === null || _r === void 0 ? void 0 : _r.publicURL }));
                }
                break;
            }
            case "code": {
                var regexp = /belief\(([A-Za-z]+)\|(.*?)\)/;
                var result = e.children[0].value.match(regexp);
                var beliefSlug = typeof result[1] !== "undefined" ? result[1] : false;
                var beliefTitle = typeof result[2] !== "undefined" ? result[2] : false;
                var Belief = hooks.belief;
                if (beliefSlug && beliefTitle)
                    return (react_1.default.createElement(Belief, { key: thisId, value: { slug: beliefSlug, title: beliefTitle }, cssClasses: injectClassNames }));
                break;
            }
            case "ul":
            case "ol":
                rawElement = e === null || e === void 0 ? void 0 : e.children.filter(function (e) { return !(e.type === "text" && e.value === "\n"); });
                contents = (0, exports.HtmlAstToReact)(payload, rawElement, thisClassNames, hooks, memory);
                if ((e === null || e === void 0 ? void 0 : e.tagName) === "ol")
                    return (react_1.default.createElement("ol", { key: thisId, className: classNames(injectClassNames) }, contents));
                if ((e === null || e === void 0 ? void 0 : e.tagName) === "ul")
                    return (react_1.default.createElement("ul", { key: thisId, className: classNames(injectClassNames) }, contents));
                break;
            case "li":
                contents = (_s = e === null || e === void 0 ? void 0 : e.children) === null || _s === void 0 ? void 0 : _s.map(function (li) {
                    return (0, exports.HtmlAstToReact)(payload, [li], thisClassNames, hooks, memory);
                });
                return (react_1.default.createElement("li", { className: classNames(injectClassNames), key: thisId }, contents));
            case "br":
                return react_1.default.createElement("br", { key: thisId });
            case "em":
                if (typeof ((_t = e === null || e === void 0 ? void 0 : e.children[0]) === null || _t === void 0 ? void 0 : _t.value) === "string") {
                    return react_1.default.createElement("em", { key: thisId }, (_u = e === null || e === void 0 ? void 0 : e.children[0]) === null || _u === void 0 ? void 0 : _u.value);
                }
                break;
            case "strong":
                if (typeof ((_v = e === null || e === void 0 ? void 0 : e.children[0]) === null || _v === void 0 ? void 0 : _v.value) === "string") {
                    return react_1.default.createElement("strong", { key: thisId }, (_w = e === null || e === void 0 ? void 0 : e.children[0]) === null || _w === void 0 ? void 0 : _w.value);
                }
                break;
            case "blockquote":
                rawElement = e === null || e === void 0 ? void 0 : e.children.filter(function (e) { return !(e.type === "text" && e.value === "\n"); });
                contents = (0, exports.HtmlAstToReact)(payload, rawElement, thisClassNames, hooks, memory);
                if (typeof ((_x = e === null || e === void 0 ? void 0 : e.children[0]) === null || _x === void 0 ? void 0 : _x.value) === "string") {
                    return (react_1.default.createElement("blockquote", { className: classNames(injectClassNames), key: thisId }, contents));
                }
                break;
            default:
                console.log("helpers.js: MISS on", e);
        }
        return null;
    });
    return composed;
};
exports.HtmlAstToReact = HtmlAstToReact;
var getLogo = function (fieldSvgLogo, fieldImageLogo, viewportKey, GatsbyImage) {
    var _a, _b, _c, _d;
    // svg or image logo?
    if (typeof ((_a = fieldSvgLogo === null || fieldSvgLogo === void 0 ? void 0 : fieldSvgLogo.localFile) === null || _a === void 0 ? void 0 : _a.publicURL) === "string") {
        // svg logo
        var thisImageId = fieldSvgLogo === null || fieldSvgLogo === void 0 ? void 0 : fieldSvgLogo.id;
        var thisImage = (_b = fieldSvgLogo === null || fieldSvgLogo === void 0 ? void 0 : fieldSvgLogo.localFile) === null || _b === void 0 ? void 0 : _b.publicURL;
        return (react_1.default.createElement("img", { key: thisImageId, src: thisImage, className: "menu__logo", alt: "Logo" }));
    }
    else if (typeof ((_c = fieldImageLogo === null || fieldImageLogo === void 0 ? void 0 : fieldImageLogo.localFile) === null || _c === void 0 ? void 0 : _c.childImageSharp[viewportKey]) !==
        "undefined") {
        var thisImageId = fieldImageLogo === null || fieldImageLogo === void 0 ? void 0 : fieldImageLogo.id;
        var thisImage = (_d = fieldImageLogo === null || fieldImageLogo === void 0 ? void 0 : fieldImageLogo.localFile) === null || _d === void 0 ? void 0 : _d.childImageSharp[viewportKey];
        // image logo
        return (react_1.default.createElement(GatsbyImage, { key: thisImageId, className: "menu__logo", alt: "Logo", image: thisImage, objectFit: "contain" }));
    }
    return react_1.default.createElement(react_1.default.Fragment, null);
};
exports.getLogo = getLogo;
var tractStackGraph = function (data) {
    var tractStackId = data[0].node.relationships.field_tract_stack.id;
    var tractStackTitle = data[0].node.relationships.field_tract_stack.title;
    var graph = data.map(function (e) {
        var storyFragmentId = e.node.id;
        var storyFragmentTitle = e.node.title;
        var storyFragmentSlug = e.node.field_slug;
        return {
            id: storyFragmentId,
            title: storyFragmentTitle,
            slug: storyFragmentSlug,
        };
    });
    return {
        id: tractStackId,
        title: tractStackTitle,
        graph: graph,
    };
};
exports.tractStackGraph = tractStackGraph;
function classNames() {
    var classes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        classes[_i] = arguments[_i];
    }
    return classes.filter(Boolean).join(" ");
}
exports.classNames = classNames;
// modified from gatsby-shopify-starter
var formatPrice = function (currency, value) {
    return Intl.NumberFormat("en-US", {
        currency: currency,
        minimumFractionDigits: 2,
        style: "currency",
    }).format(value);
};
exports.formatPrice = formatPrice;
// modified from gatsby-shopify-starter
var getCurrencySymbol = function (currency, locale) {
    var _a;
    if (locale === void 0) { locale = undefined; }
    if (!currency) {
        return;
    }
    var formatter = Intl.NumberFormat(locale, {
        currency: currency,
        style: "currency",
    });
    var parts = formatter.formatToParts(100);
    var symbol = ((_a = parts === null || parts === void 0 ? void 0 : parts.find(function (part) { return part.type === "currency"; })) === null || _a === void 0 ? void 0 : _a.value) || "$";
    var formatted = formatter.format(100);
    var symbolAtEnd = formatted.endsWith(symbol);
    return { symbol: symbol, symbolAtEnd: symbolAtEnd };
};
exports.getCurrencySymbol = getCurrencySymbol;
//# sourceMappingURL=helper.js.map